#ifndef SBW_BROKER_INTERFACE
#define SBW_BROKER_INTERFACE

#include <string>
#include <vector>

#include "SBW.h"

#include "SBW/SBWRPC.h"
#include "SBW/DataBlockWriter.h"

using namespace std;
using namespace SystemsBiologyWorkbench;

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{
		class BrokerInterface
		{
		public:
			BrokerInterface(int nId);
			string getVersion();
			vector< DataBlockWriter > findServices(string category, bool recursive);
			DataBlockWriter getModuleDescriptor(string moduleName, bool includeRunning);
			DataBlockWriter getModuleDescriptor(int moduleId);
			vector< DataBlockWriter  > getModuleDescriptors(bool localOnly, bool includeRunning);
			int getModuleInstance(string moduleName);
			vector< string > getServiceCategories(string parentCategory);
			int linkBroker(string hostNameOrAddress);
			vector<int> getExistingModuleInstanceIds();
			void changeModuleName(int moduleId, string newModuleName);
			DataBlockWriter  getServiceDescriptor(int moduleId, int serviceId);
			DataBlockWriter getServiceDescriptor(int moduleId, string serviceName);
			vector<DataBlockWriter > getServiceDescriptors(int moduleId);
			vector<DataBlockWriter > getServiceDescriptors(string moduleName);
			void registerModule(string moduleName, string moduleDisplayName,
				int moduleType, string commandLine,
				string helpString);
			void registerService(string moduleName, string serviceName,
				string serviceDisplayName, string category,
				string helpString);
			void shutdownBroker();
			void unregisterModule(string moduleName);
		private:
			int m_nId;
			SBWRPC *m_oRPC;
		};
	}
}

#endif
