#ifndef SBW_BROKER_MODULE_REGISTRY
#define SBW_BROKER_MODULE_REGISTRY

#include "ModuleRegistryFile.h"
#include "SBW/ModuleDescriptor.h"

#include <string>
#include <vector>
#ifndef WIN32
// don't forget to add a std::string compare function to stl_hash_fun.h
#include <ext/hash_map>
using namespace std;
using namespace __gnu_cxx;
#else
#include <hash_map>
using namespace std;
#endif

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{
		class ModuleRegistry
		{
		private:
			ModuleRegistry();
		public:
			static ModuleRegistry *getRegistry();
			void addModuleDescriptor(string moduleName, ModuleDescriptor *md);
			void addModuleDescriptor(string moduleName, ModuleDescriptor *md,
				bool doCheckpoint);
			void addModuleDescriptor(string moduleName, string moduleDisplayName,
				int moduleType, string commandLine, string help);
			void removeModuleDescriptor(string moduleName);
			ModuleDescriptor *getModuleDescriptor(string moduleName);
			vector<ModuleDescriptor *> getModuleDescriptors();
			static void registerModules();
		private:
			ModuleRegistry *readResolve(); 
			typedef pair< string , ModuleDescriptor *> StringMD;
			hash_map< string , ModuleDescriptor *> table;
			static ModuleRegistryFile *registryFile;
			static ModuleRegistry *instance;
		};
	}
}

#endif

