#ifndef SBW_BROKER_MODULE_REGISTRY_FILE
#define SBW_BROKER_MODULE_REGISTRY_FILE

#include "SBW/ModuleDescriptor.h"
#include "SBW/ServiceDescriptor.h"

#include "libxml/parser.h"

#include <string>
#include <fstream>
#include <iostream>

namespace SystemsBiologyWorkbench
{	
	namespace Broker
	{
		class ModuleRegistry;

		class ModuleRegistryFile
		{
		public:
			ModuleRegistryFile(ModuleRegistry *registry);
			~ModuleRegistryFile();
			bool exists();
			std::string getPath();
		private:
			std::string getRegistryFile();
			std::string removeQuotes(std::string);
		public:
			void checkpoint();
			void printStats();
			void readRegistry();
			
		private:
			void writeRegistryFile();
			xmlChar * ConvertInput(const char *in, const char *encoding);
			void parseNode(xmlNode * node);

			int typeToInt(std::string type);
			std::string getAttributeValue(xmlNode *elem, std::string attrName);
			static ModuleRegistry *registry;
			static std::string registryFile;

			static xmlNode *registryRoot;
			static xmlDoc *registryDoc;
			static xmlNode *registryListOfModules;
		};
	}
}

#endif

