#ifndef SBW_BROKER_PROXY_LOCAL_BROKER_INSTANCE
#define SBW_BROKER_PROXY_LOCAL_BROKER_INSTANCE

#include "BrokerDefines.h"
#include "InstanceBase.h"
#include "Instance.h"
#include "SBWBrokerRPC.h"

#include "SBW/SBWRPC.h"

#include <string>
#include <iostream>

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{
		class ProxyLocalBrokerInstance : 
			public InstanceBase
		{
		private:
			static SBWRPC *rpc;
			SBWOSMutex transmitMutex ;
		public:
			ProxyLocalBrokerInstance();
			bool connect(std::string key);
			void transmit(unsigned char *data, int length);
			void disconnect();
		};
	}
}

#endif

