#include "StartupNotification.h"
#include "StringUtil.h"

#include <iostream>
#include <string>
#include "SBW/portableOS.h"


using namespace SystemsBiologyWorkbench::Broker;
using namespace SystemsBiologyWorkbench;
using namespace std;

void StartupNotification::addWatcher(StartupNotification::Watcher *watcher)
{
	startupWatchers.push_back(watcher);
}
StartupNotification::Watcher *StartupNotification::matchWatcher(std::string str, int brokerId)
{
	if (StringUtil::empty(str))
		return NULL;


	for (unsigned int i = 0; i < startupWatchers.size(); i++ )
	{
		Watcher *watcher = (Watcher*) startupWatchers[i];
		if (watcher->match(str, brokerId))
		{
			//TRACE("Matched waiting for '"  << str <<  "', broker id " << brokerId)
			return watcher;
		}
	}
	return NULL;
}
void StartupNotification::removeWatcher(StartupNotification::Watcher *watcher)
{
	vector <Watcher *>::iterator oIterator;
	for ( oIterator = startupWatchers.begin( ) ; oIterator != startupWatchers.end( ) ; oIterator++ )
		if ( (*oIterator) == watcher)
			startupWatchers.erase( oIterator);		
}
std::vector<StartupNotification::Watcher *> StartupNotification::startupWatchers;
