#include "StringUtil.h"
#include "Properties.h"

#include <string>
#include <vector>

#include "SBW/SBW.h"

#ifndef WIN32
typedef char byte; 
#endif

using namespace std;
using namespace SystemsBiologyWorkbench::Broker;

std::string StringUtil::HEX = "0123456789ABCDEF";


std::vector<int> StringUtil::parseRange(std::string rangeStr)
{
	std::vector<int> oResult;
	if (empty(rangeStr))
	{
		TRACE("Null range given")
			return parseRange("10102-10202"); // default port range
	}


	int nPos = rangeStr.find ('-');
	std::string sLow = rangeStr.substr(0,nPos);
	std::string sHigh = rangeStr.substr(nPos+1);
	oResult.push_back(Properties::toInt(sLow));
	oResult.push_back(Properties::toInt(sHigh));

	return oResult;
}
std::string StringUtil::toHex(char data[], int nLength)
{
	std::stringstream str;
	for (int i = 0; i < nLength; i++)
	{
		byte b = data[i];
		int hi = (b & 0xF0) >> 4;
		int lo = (b & 0x0F);
		str << HEX.at(hi) <<  HEX.at(lo);
	}
	return str.str();
}
std::vector<std::string> StringUtil::parseReply(char *oReply, int nLength)
{
	std::vector<std::string> oResult;
	int nStart = 0;
	int nEnd = nLength;
	while (findNextBorder(oReply, nLength, nStart,  nEnd) < nLength)
	{
		nStart = findNextBorder(oReply, nLength, nStart,  nEnd);
		std::string sTemp (oReply);
		oResult.push_back(sTemp);
	}
	return oResult;
}
int StringUtil::findNextBorder(char *oString, int nLength, int nStart, int nEnd)
{
	if ((nStart +3) >= nLength)
		return nEnd;
	else 
	{
		return strlen(oString);
	}

}
