#ifndef SBW_SYS
#define SBW_SYS

#include "SBW/SBWOSSocket.h"

#include <string>
#include <iostream>
#include <vector>

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{
		class Sys
		{
		public:

			static std::string getHostName();
			static std::string getHostAddress(std::string host);
			static std::string getHostAddress();
			static std::string getTimeStamp();
			static std::string fullyQualifiedHostName(std::string host);
			static int findFreePort(std::vector<int> portRange, bool remoteAccessible);
			static bool portInUse(int port, bool remoteAllowed);	
			static void receive(SOCKET sock, unsigned char *data, Integer length);
			static int  readInteger(SOCKET sock);
			static std::string readString (SOCKET sock);
			static bool isSecure();

		private :
			static bool isAddress(std::string str);
			Sys(){ }// No op.

		};
	}
}
#endif
