#include "QpGenData.h"
#include "QpGenVars.h"
#include "QpGenResiduals.h"
#include "GondzioSolver.h"
#include "QpGenSparseMa27.h"
#include <math.h>
#include <iostream.h>
#include <string>
#include <fstream.h>
#include <strstream.h>
  
#include "qps.h"
#include "supergene.h"

#include "data.h"
void read_gene_name(char * name, string * CC, int nnn);

string gene_name[1000];
Supergene sgene[1000];

int main (int a, char * b[])
{
  
	int quiet = 1;
	int index;

	QPS X(b[1]);
	// export the size of the problem
	X.Export_I(nx, my,  mz, nnzQ, nnzA,nnzC);

	c = new double[nx];


	xupp= new double[nx];
	ixupp= new char[nx];;

	xlow= new double[nx];
	ixlow= new char[nx];

	bA       = new double[my];;
	irowA    = new int[nnzA];
	jcolA    = new int[nnzA];
	dA       = new double[nnzA];

	Cname = new string[nx];
        Rname = new string[my];

	cout << " nx = " << nx << endl;
	cout << " my = " << my << endl;
										
	X.Export_D(c,xlow,ixlow,xupp,ixupp,irowA,jcolA,dA,bA,Cname,Rname);
	sort(irowA, jcolA, nnzA, my, dA);
	read_gene_name(b[2], Cname, nx);

	exit(1);

	if (a >2) {
        index = search(Cname, nx, (string) b[2] );
        cout << " --- index = " << index << endl;
        xlow[index]  = 0.0;
        xupp[index]  = 0.0;
        ixlow[index] = (char) 1;
        ixupp[index] = (char) 1;
	}
							
	// set up dimensions
 	QpGenSparseMa27 * qp = new QpGenSparseMa27( nx, my, mz, nnzQ, nnzA, nnzC );

	// make data
  	QpGenData      * prob = (QpGenData *) qp->copyDataFromSparseTriple(
        c,      irowQ,  nnzQ,   jcolQ,  dQ,
        xlow,   ixlow,  xupp,   ixupp,
        irowA,  nnzA,   jcolA,  dA,     bA,
        irowC,  nnzC,   jcolC,  dC,
        clow,   iclow,  cupp,   icupp );

	// make variable, given input data
  	QpGenVars      * vars  = (QpGenVars *) qp->makeVariables( prob );
  	QpGenResiduals * resid = (QpGenResiduals *) qp->makeResiduals( prob );
  
	// solver object
  	GondzioSolver  * s     = new GondzioSolver( qp, prob );
  
  	if( !quiet ) s->monitorSelf();
  	int ierr = s->solve(prob,vars, resid);
  	if( ierr == 0 ) {
    		cout.precision(8);
    		cout << "Solution: \n";
		vars->x->copyIntoArray(c);
    		// vars->x->writefToStream( cout, "x[%{index}] = %{value}" );
		// for (int i=0; i< nx; i++)
		//	cout << "c[" << i << "]= " << c[i] << endl;
  	} 
	else 
	{
    		cout << "Could not solve the problem.\n";
  	}
	cout << " ------ Objective value = " << c[742] << endl;

	exit(1);


	
	// now perform the quadratic projection:
	// vector c is now the new objective function,
	// make matrix Q to be identity and list all its diagonal elements
	index = search(Cname, nx, "TPIAR");
	cout << index << endl;	
	xlow[index]  = 0.0;
	xupp[index]  = 0.0;
	ixlow[index] = (char) 1;
	ixupp[index] = (char) 1;
/*
	dQ = new double[nx];
	irowQ = new int[nx];
	jcolQ = new int[nx];

	for (int i=0; i<nx; i++)
	{
		irowQ[i] = i;
		jcolQ[i] = i;
		dQ[i] = 1.0;
	}
	nnzQ = nx;
*/
	// set up dimensions
 	QpGenSparseMa27 * qpm = new QpGenSparseMa27( nx, my, mz, nnzQ, nnzA, nnzC );

	// make data
  	QpGenData      * probm = (QpGenData *) qpm->copyDataFromSparseTriple(
        c,      irowQ,  nnzQ,   jcolQ,  dQ,
        xlow,   ixlow,  xupp,   ixupp,
        irowA,  nnzA,   jcolA,  dA,     bA,
        irowC,  nnzC,   jcolC,  dC,
        clow,   iclow,  cupp,   icupp );

	// make variable, given input data
  	QpGenVars      * varsm  = (QpGenVars *) qpm->makeVariables( probm );
  	QpGenResiduals * residm = (QpGenResiduals *) qpm->makeResiduals( probm );
  
	// solver object
  	GondzioSolver  * sm     = new GondzioSolver( qpm, probm );
  
  	if( quiet ) sm->monitorSelf();
  	ierr = sm->solve(probm,varsm, residm);
  	if( ierr == 0 ) {
    		cout.precision(8);
    		cout << "Solution: \n";
		varsm->x->copyIntoArray(c);
    		// vars->x->writefToStream( cout, "x[%{index}] = %{value}" );
		for (int i=0; i< nx; i++)
			cout << "c[" << i << "]= " << c[i] << endl;
  	} 
	else 
	{
    		cout << "Could not solve the problem.\n";
  	}

	cout << "c[742] = " << c[742] << endl;
	return 0;
}


void read_gene_name(char * fname, string * CC, int num_flux)
{
	ifstream input;
	input.open(fname);
	string s,ss;
	string process_name;

	int i=0;
	while (getline(input, s, '\n'))
	{
	     if (s.size() > 2)
	     {
		if (s[0] == '#')
		{
			// get the process name
			process_name = s;
		}
		else if (s[0] == '?')
		{
			// do nothing
		}
		else
		{
			// get a gene name
			// put it into an array type string
		     	// cout << s.size() << " \t" << s << endl;
			istrstream line( (char *) s.c_str() );
			line >> ss;
			Cap(ss);
				gene_name[i] = ss;
				sgene[i].gene_name = ss;
				sgene[i].insert(ss);
				sgene[i].process_name = process_name;
				// cout << ss.size() << " \t" << gene_name[i] << endl;
			while (line >> ss)
			{
				Cap(ss);
				sgene[i].insert(ss);
			}
			i++;
		
		}
             }
		
	}

	// number of supergenes
	int num_gene = i;

	cout << " Number of Fluxes inside read_gene_name = " << num_flux << endl;
	cout << " Number of super genes = " << num_gene << endl;

	int isize = 0;
	int flag[1000] ;
	int count = 0;
	// loop over all read super genes
	for (i=0;i<num_gene;i++)
	{
	     flag[i] = 0;

	     // for each gene in the super gene cluster
	     for (int k=0; k<sgene[i].curr_gene_num; k++)
	     {
		// get gene name as well as its size
		isize = sgene[i].iso_enzyme[k].size();
		ss = sgene[i].iso_enzyme[k];
		
		// now search for its corresponding fluxes
		for (int j=0; j<num_flux;j++)
		{
			if (isize == 3)
			{
				// compare only three letters
				if (CC[j].substr(0,3) == ss.substr(0,3))
				{	
					flag[i] = 1;
					sgene[i].insert(j, CC[j]);	
				}
			}
			else if (isize > 3)
			{
				// compare only four letters
				if (CC[j].substr(0,4) == ss.substr(0,4))
				{
					flag[i] = 1;
					sgene[i].insert(j, CC[j]);
				}
			}
		}
	     } // end of each gene in the super gene cluster loop
	     if (flag[i] == 0)
	     {
		cout << " =========== " << sgene[i].gene_name << "  =========== " << endl;
	        count++;
	     }		
	}
	cout << " Number of super genes  = " << num_gene << endl;
	cout << " Number of known fluxes = " << num_gene - count  << endl;
	for (int j=0;j<i;j++)
		sgene[j].print();

	string st;
	for (int j=0; j<i-1; j++)
	{
		for (int k=j+1; k<i; k++)
		{
			if (gene_name[k] == gene_name[j])
				cout << j << ": "<< gene_name[j] << " ------ " << k << ": " << gene_name[k] << endl;
		}
	}
		
	// find all corresponding fluxes
	// find indices
	// if gene_name.size() == 3, compare 3 letters
	// if gene_name.size() >= 4, compare 4 letters
	// print out all corresponding fluxes and their indices
}
