#include "QpGenData.h"
#include "QpGenVars.h"
#include "QpGenResiduals.h"
#include "GondzioSolver.h"
#include "QpGenSparseMa27.h"
#include <math.h>
#include <iostream.h>
#include <string>
#include <fstream.h>
#include <strstream.h>
  
#include "qps.h"
#include "supergene.h"

#include "data.h"
#include "data2.h"

int main (int a, char * b[])
{
  
	int quiet = 1;
	int index;

	// create QPS object to read QPS file
	QPS X(b[1]);
	// export the size of the problem
	X.Export_I(nx,  my,   mz,  nnzQ,  nnzA,  nnzC);
	X.Export_I(nxq, myq,  mzq, nnzQq, nnzAq, nnzCq);

	c = new double[nx];
	x = new double[nx];

	xupp= new double[nx];
	ixupp= new char[nx];;

	xlow= new double[nx];
	ixlow= new char[nx];

	bA       = new double[my];;
	irowA    = new int[nnzA];
	jcolA    = new int[nnzA];
	dA       = new double[nnzA];

	// data for second object
	xuppq= new double[nx];
	ixuppq= new char[nx];;

	xlowq= new double[nx];
	ixlowq= new char[nx];

	bAq       = new double[my];;
	irowAq    = new int[nnzA];
	jcolAq    = new int[nnzA];
	dAq       = new double[nnzA];

	
	// Cname = Flux name (column), Rname = row name (metabolites)
	Cname = new string[nx];
        Rname = new string[my];

	X.Export_D(c,xlow,ixlow,xupp,ixupp,irowA,jcolA,dA,bA,Cname,Rname);
	X.Export_D(x,xlowq,ixlowq,xuppq,ixuppq,irowAq,jcolAq,dAq,bAq,Cname,Rname);
	sort(irowA,  jcolA,  nnzA,  my,  dA);
	sort(irowAq, jcolAq, nnzAq, myq, dAq);

	/*
	int j=0;
	cout << "String Flux_Name[] = { ";
	for (int i=0; i< nx; i++)
	{
		cout << "\"" << Cname[i] << "\", ";
		if ((i%10) == 0)
			cout << endl;
	}
	cout << "};";
	exit(1);
	*/	
		
        /* index = search(Cname, nx, (string) b[3]);
	cout << index << endl;
	cout << ixlowq[index] << " <-xlow, xupp-> " << ixupp[index] << endl;
	xlow[index]  = 0.0;
	xupp[index]  = 0.0;
	ixlow[index] = (char) 1;
	ixupp[index] = (char) 1;
	*/

	// process gene names and find all coresponding fluxes
	read_gene_name(b[2], Cname, nx);

	exit(1);
	// set up dimensions
 	QpGenSparseMa27 * qp = new QpGenSparseMa27( nx, my, mz, nnzQ, nnzA, nnzC );

	// make data
  	QpGenData      * prob = (QpGenData *) qp->copyDataFromSparseTriple(
        c,      irowQ,  nnzQ,   jcolQ,  dQ,
        xlow,   ixlow,  xupp,   ixupp,
        irowA,  nnzA,   jcolA,  dA,     bA,
        irowC,  nnzC,   jcolC,  dC,
        clow,   iclow,  cupp,   icupp );

	// make variable, given input data
  	QpGenVars      * vars  = (QpGenVars *) qp->makeVariables( prob );
  	QpGenResiduals * resid = (QpGenResiduals *) qp->makeResiduals( prob );
  
	// solver object
  	GondzioSolver  * s     = new GondzioSolver( qp, prob );
  
  	if( !quiet ) s->monitorSelf();
  	int ierr = s->solve(prob,vars, resid);
  	if( ierr == 0 ) {
    		
		cout.precision(4);
		vars->x->copyIntoArray(x);
		growth_valueL = x[742];
    		// vars->x->writefToStream( cout, "x[%{index}] = %{value}" );
		for (int i=0; i< nx; i++)
		{
			x[i] = -2.0*x[i];
		}
  	} 
	else 
	{
		cout << " cannot solve the problem " << endl;
		growth_valueL  = 0.0;
		exit(1);
  	}
	cout << "Growth value for LP  = " << growth_valueL  << endl;

	// negate the objective function
	for (int i=0; i< nx; i++)
		x[i] = -1.0*x[i];

	delete qp; delete prob; delete vars; delete resid; delete s;
	

	///////////////////////////////////////////////////////////////////////////
	// now perform the quadratic projection:
	// vector x is now the new objective function,
	// make matrix Q to be identity and list all its diagonal elements
	///////////////////////////////////////////////////////////////////////////

	index = search(Cname, nx, "GLK1");
	cout << "GLK1 Index = " << index << endl;	
	xlowq[index]  = 0.0;
	xuppq[index]  = 0.0;
	ixlowq[index] = (char) 1;
	ixuppq[index] = (char) 1;

	// set up the Q-matrix for QP
	nnzQq = 0; // nxq;
	dQq = new double[nxq];
	irowQq = new int[nxq];
	jcolQq = new int[nxq];
	for (int i=0; i<nxq; i++)
	{
		irowQq[i] = i;
		jcolQq[i] = i;
		dQq[i]    = 0.5;
	}
	
	// set up dimensions
 	QpGenSparseMa27 * qpm = new QpGenSparseMa27( nxq, myq, mzq, nnzQq, nnzAq, nnzCq );

	// make data
  	QpGenData * probm = (QpGenData *) qpm->copyDataFromSparseTriple(
        c,       irowQq,  nnzQq,   jcolQq,  dQq,
        xlowq,   ixlowq,  xuppq,   ixuppq,
        irowAq,  nnzAq,   jcolAq,  dAq,     bAq,
        irowCq,  nnzCq,   jcolCq,  dCq,
        clowq,   iclowq,  cuppq,   icuppq );

	// make variable, given input data
  	QpGenVars * varsm  = (QpGenVars *) qpm->makeVariables( probm );
  	QpGenResiduals * residm = (QpGenResiduals *) qpm->makeResiduals( probm );
  
	// solver object
  	GondzioSolver *sm     = new GondzioSolver( qpm, probm );
  
  	if( !quiet ) sm->monitorSelf();
  	int ierrq = sm->solve(probm,varsm, residm);
  	if( ierrq == 0 ) {
    		cout.precision(4);
		varsm->x->copyIntoArray(x);
		growth_valueQ = x[742]; 
  	} 
	else 
	{
		cout << "Cannot solve the QP problem " << endl;
		exit(1);
		growth_valueQ = 0.0;
  	}

	cout << "Growth Value for QP  = " << growth_valueQ  << endl;
	return 0;
}


void read_gene_name(char * fname, string * CC, int num_flux)
{
	ifstream input;
	input.open(fname);
	string s,ss;
	string process_name;

	int i=0;
	while (getline(input, s, '\n'))
	{
	     if (s.size() > 2)
	     {
		if (s[0] == '#')
		{
			// get the process name
			process_name = s;
		}
		else if (s[0] == '?')
		{
			// do nothing
		}
		else
		{
			// get a gene name
			// put it into an array type string
		     	// cout << s.size() << " \t" << s << endl;
			istrstream line( (char *) s.c_str() );
			line >> ss;
			Cap(ss);
				gene_name[i] = ss;
				sgene[i].gene_name = ss;
				sgene[i].insert(ss);
				sgene[i].process_name = process_name;
				// cout << ss.size() << " \t" << gene_name[i] << endl;
			while (line >> ss)
			{
				Cap(ss);
				sgene[i].insert(ss);
			}
			i++;
		
		}
             }
		
	}

	// number of supergenes
	num_gene = i;

	cout << " Number of Fluxes inside read_gene_name = " << num_flux << endl;
	cout << " Number of super genes = " << num_gene << endl;

	int isize = 0;
	int flag[1000] ;
	int count = 0;
	// loop over all read super genes
	for (i=0;i<num_gene;i++)
	{
	     flag[i] = 0;

	     // for each gene in the super gene cluster
	     for (int k=0; k<sgene[i].curr_gene_num; k++)
	     {
		// get gene name as well as its size
		isize = sgene[i].iso_enzyme[k].size();
		ss = sgene[i].iso_enzyme[k];
		
		// now search for its corresponding fluxes
		for (int j=0; j<num_flux;j++)
		{
			if (isize == 3)
			{
				// compare only three letters
				if (CC[j].substr(0,3) == ss.substr(0,3))
				{	
					flag[i] = 1;
					sgene[i].insert(j, CC[j]);	
				}
			}
			else if (isize > 3)
			{
				// compare only four letters
				if (CC[j].substr(0,4) == ss.substr(0,4))
				{
					flag[i] = 1;
					sgene[i].insert(j, CC[j]);
				}
			}
		}
	     } // end of each gene in the super gene cluster loop
	     if (flag[i] == 0)
	     {
		// cout << " =========== " << sgene[i].gene_name << "  =========== " << endl;
	        count++;
	     }		
	}
	//  cout << " Number of super genes  = " << num_gene << endl;
	// cout << " Number of known fluxes = " << num_gene - count  << endl;
	for (int i=0;i<num_gene;i++)
	{
		// make sure that the last node is defined gene
		while (num_gene > 0)
		{
			if (flag[num_gene-1] == 0)
			{
				num_gene--;
			}
			else if (flag[num_gene-1] == 1)
				break;
		}
		if (flag[i] == 0)
		{
			sgene[i].copy( sgene[num_gene-1]);
			num_gene--;
		}
	}
	for (int i=0;i<num_gene;i++)
		sgene[i].print();

	cout << " Final number of known supergenes = " << num_gene << endl;
	string st;
	for (int j=0; j<i-1; j++)
	{
		for (int k=j+1; k<i; k++)
		{
			if (gene_name[k] == gene_name[j])
				cout << j << ": "<< gene_name[j] << " ------ " << k << ": " << gene_name[k] << endl;
		}
	}
		
	// find all corresponding fluxes
	// find indices
	// if gene_name.size() == 3, compare 3 letters
	// if gene_name.size() >= 4, compare 4 letters
	// print out all corresponding fluxes and their indices
}
