const int NIG      = 20;		// maximun number of edges for each node allowed 
const int NIF      = 100;		// maximun number of edges for each node allowed 

class Supergene
{
   public:
        Supergene();
        ~Supergene();
	void insert(const string s);
	void insert(const int nn, const string flux);
	void copy(Supergene & sg);
	void print();
	string gene_name;
	string process_name;
	string iso_enzyme[NIG];
        int  flux_index[NIF];
	string flux_name[NIF];
        int curr_gene_num, curr_flux_num;
} ;


Supergene::Supergene()
{
          curr_gene_num = 0;
          curr_flux_num = 0;
	  gene_name = "";
	  process_name = "";
          for (int i=0;i<NIG;i++)
          {
		iso_enzyme[i] = "";
          }
          for (int i=0;i<NIF;i++)
          {
		flux_index[i] = -1;
          }
}


Supergene::~Supergene()
{ ; }

void Supergene::copy(Supergene & sg)
{
	gene_name    = sg.gene_name;
	process_name = sg.process_name;
	curr_gene_num = sg.curr_gene_num;
	curr_flux_num = sg.curr_flux_num;

	for (int i=0; i< curr_gene_num; i++)
		iso_enzyme[i] = sg.iso_enzyme[i];	

	for (int i=0; i<curr_flux_num; i++)
	{
		flux_name[i] = sg.flux_name[i];
		flux_index[i] = sg.flux_index[i];
	}
}

void Supergene::insert(const string s)
{
        if (curr_gene_num>=NIG)
        {
                cerr << " Number of isoenzymes is > " << NIG << ". Exit now! " << endl;
                cerr << "at gene = " << gene_name<< endl;
                exit(1);
        }
	iso_enzyme[curr_gene_num] = s;
	curr_gene_num++;
}

void Supergene::insert(const int nn, const string flux)
{
	if (curr_flux_num > NIF)
	{
		cerr << " Number of iso_fluxes is > " << NIF << ". Exit now! " << endl;
		cerr << "at gene = " << gene_name<< endl;
		exit(1);
	}
	flux_index[curr_flux_num] = nn;
	flux_name[curr_flux_num] = flux;
	curr_flux_num++;
}

void Supergene::print()
{
	if (curr_gene_num > 1) 
	{
		// cout << gene_name << ", " ;
		for (int i=0;i<curr_gene_num;i++)
			cout << iso_enzyme[i] << ", " ;
		if ( curr_flux_num ==0)
			cout << " No Flux matched! " << endl;
		else
		{
			cout << " -- Fluxes -- " ;
			for (int i=0;i<curr_flux_num; i++)
				cout << flux_name[i] << "(" << flux_index[i] << ") " ;
			cout << endl;
		}
	}
	else
	{
		cout << gene_name ;
		if ( curr_flux_num ==0)
			cout << " No Flux matched! " << endl;
		else 
		{
			cout << " -- Fluxes -- " ;
			for (int i=0;i<curr_flux_num; i++)
				cout << flux_name[i] << "; " ;
			cout << endl;
		}
	}
}

//////////////////////////////////////////////////////////////////
// Function: Cap
//           This function will take in a word, convert lower case
//           letter to the corresponding capital  letter
///////////////////////////////////////////////////////////////////

        void Cap( string & x)
        {
                int temp;
                int len = x.size();
                int i = 0;
		int offset = ('a' - 'A');
                while (1)
                {

                        if (i==len)
                                break;
                        temp = (int) x[i] ;
                        if ((temp >= 'a') && (temp <= 'z'))
                                temp = temp - offset;
                        x[i] = (char) temp;
                        i++;
                }

        }

