/*******************************************
File qps.h: Header file for Class QPS

This class is used to parse the the input
file in the QPS (or MPS) format and return
input data  in the appropriate form 
specified by the OOQP package
********************************************/

#ifndef _QPS_H
#define _QPS_H

#include <iostream.h>
#include <string>
#include <sstream>

class QPS
{ 
  public: 
	// Constructors: take filename as argument
        QPS(string ifilemane);

	// destructor for Atom class
        ~QPS();
	
	// this function must be called first. Read in the NAME card
	void START();

	// read in the ROWS section of the input file. Make sure that this
	// is called imediately after START()
	void ROWS();

	// read in the COLUMN section of the input file. Make sure that this
	// is called imediately after ROWS()
	void COLUMN();

	// read in the RANGES section of the input file.
	void RANGES();

	// read in the RHS section of the input file. For the current purpose
	// this function set vector b to zero:  S*v = 0
	void RHS();

	// read in the BOUND section of the input file
	void BOUND();

	// read in the QUADOBJ section of the input file
	void QUADOBJ();

	// set all flag to make sure that the reading is fine
	void ENDATA();


private:
	void read_section();
	string filename;
	string current_token;
	int    calling_seq;
 	string num_to_string(int n);

}; 

#endif

