
#include "LpQpSolution.h"
#include <math.h>

const double ZERO=0.0001;
const double DELTA=0.5;

LpQpSolution::LpQpSolution()
{
	iGene=-1; jGene=-1;
	iGeneQP = 0.0;
	jGeneQP = 0.0;
	iGeneDoubleMutantQP = 0.0;
	jGeneDoubleMutantQP = 0.0;
	ijGeneDoubleMutantLP= 0.0;

	flagOfInterest = 0;
}
int LpQpSolution::howInteresting()
{
	bool flag=false;

	// large difference in QP solution
	if (fabs(iGeneQP - jGeneQP) > DELTA)
		flagOfInterest=1;

	// synthetic lethality
	if ((iGeneQP > ZERO) && ( jGeneQP > ZERO) && (ijGeneDoubleMutantLP < ZERO))
	{
		flagOfInterest=2;
		flag = true;
	}
	// but QP is not zero for double mutant
	if ( (flag) && ( iGeneDoubleMutantQP > ZERO) )
	{
		flagOfInterest=3;	
		if ( fabs(iGeneDoubleMutantQP - jGeneDoubleMutantQP) > DELTA)
			flagOfInterest=4;
	}

	if ( fabs(iGeneDoubleMutantQP - jGeneDoubleMutantQP) > DELTA)
		flagOfInterest=5;

	return flagOfInterest;
}
void   LpQpSolution::setIJ(const int i, const int j)
{
	iGeneQP = i;
	jGeneQP = j;
}
LpQpSolution::~LpQpSolution()
{ ; }
