#include <iostream.h>
#include <stdlib.h>


struct Rnode {
	int	irow;
	int	jcol;
	double	value;
	Rnode  *next;
} ;

void insert(Rnode * R, Rnode * elementIJ)
{
	// sorting each column element by its index 
	int row_index = elementIJ->irow;
	int itemp;
	Rnode * curr, *prev; 
       		curr = R[row_index].next; 
		prev = &R[row_index];
	while (1)
	{
		// insert the element  
		if (curr == NULL)
		{
			prev->next = elementIJ;
			break;
		}
		else if (elementIJ->jcol < curr->jcol)  
		{
			elementIJ->next = curr;
			prev->next = elementIJ;
			break;
		}
		prev  = curr;
		curr  = curr->next;
	}
}

void print_List_node(Rnode * R, const int nrow)
{
	Rnode * curr;
	for (int i=0;i<nrow;i++)
	{
		curr = R[i].next;
		while (curr != NULL)
		{
			cout << "[ (" << curr->irow << "," << curr->jcol << "): " << curr->value << "]" ;
		       	curr = curr->next;
		}	       
		cout << endl;
	}
}
		

void OrderMatrixByRowMajorOrder(int * irowA, int * jcolA, int nnzA, int nrows, double *da)
{
	// make an array of many nodes
	int itemp;
	Rnode * RR = new Rnode[nrows];
	Rnode * node ;

	for (int i=0; i< nrows; i++)
	{
		RR[i].irow = -1;
		RR[i].jcol = -1;
		RR[i].value = 0.0;
		RR[i].next = NULL;
	}

	for (int i=0;i<nnzA;i++)
	{
		
		// make a new node and assign data
		node = new Rnode;
		node->irow   = irowA[i];
		node->jcol   = jcolA[i];
		node->value  = da[i];
		node->next   = NULL;
		if (node->irow  > nrows)
		{
			cerr << " Error in Sort Procedure " << endl;
			exit(1);
		}
		// insert the node into array of node list
		insert(RR, node);

	}
	// print_List_node(RR, nrows);
	// now get all data from an array of list node ==> irowA, jcolA, dA...
	int index = 0;
	for (int i=0;i<nrows;i++)
	{
		node = RR[i].next;
		while (node != NULL)
		{
			irowA[index] = node->irow;
			jcolA[index] = node->jcol;
			da[index]    = node->value;
			node = node->next;
			index++;
		}
	}
	if (index !=  nnzA)
	{
		cerr << " Error in copying/sort Procedure " << endl;
		exit(1);
	}
	
	 		
}

