#ifndef _QP_MANIPULATOR_H
#define _QP_MANIPULATOR_H
#include "sbmlReader.h"

using namespace std;
class QpManipulator 
{
  public: 

	// this constructor take in the global flux array and its bounds
	
	QpManipulator();
	QpManipulator(char *mpsFileName, int &nnx, int &mmy, int &mmz);
	~QpManipulator();
	void setBasicData();
	void setBasicData(double *c, int nx, int *irowQ, int nnzQ, int *jcolQ, double *dQ,  
			int *irowA, int nnzA, int *jcolA, double *dA,
			double *b, int my,
			int *irowC, int nnzC, int *jcolC, double *dC, double *clow, int mz, char *iclow, double *cupp, char *icupp);
	void generateMatrixQforLP();
	void generateMatrixQforMOMA();
	void extractDataFromSBML();
	void writeFluxToSBML(double *fluxes, const int nelements);
	void writeFluxToSBML(char * filename, double *fluxes, const int nelements);
	double CalLP(double *obj,double *xlow,char *ixlow,double *xupp,char *ixupp,double *x,double *gamma, double *phi,double *y,double *z,double *lambda,double *pi);
	double CalQP(double *obj,double *xlow,char *ixlow,double *xupp,char *ixupp,double *x,double *gamma, double *phi,double *y,double *z,double *lambda,double *pi);
	void initializeArraysAndCopyData(string *FN, double *x,double *gamma,double *phi,double *tempObj,double *objFunc,
						     double *WTSol,double *xlow,double *xupp, char *ixlow, char *ixupp, double *y,		
						     double *z, double *lambda, double *pi);
  private:
	double *c; 	// original objective function
	int nx;		//
	int *irowQ; int nnzQ; int *jcolQ; double *dQ;
	int *irowQMOMAQP; int nnzQMOMAQP; int *jcolQMOMAQP; double *dQMOMAQP;
	int *irowQMOMALP; int nnzQMOMALP; int *jcolQMOMALP; double *dQMOMALP;
	int *irowA; int nnzA; int *jcolA; double *dA;
	double *b; int my;
	int *irowC; int nnzC; int *jcolC; double *dC; double *clow; int mz; char *iclow; double *cupp; char *icupp;
	QPS *qps;
	sbmlReader *SB;
	string *FluxName, *MetaboliteName;
	double *XUPP,*XLOW;
	char *IXUPP, *IXLOW;

} ;
#endif

