#include <iostream.h>
#include "jnode.h"

Node::Node()
{
	irowa = -1;
	jcola = -1;
	da    = 0.0;
	next = NULL;
}
Node::Node(int ir, int jc, double a)
{
   	irowa = ir; jcola = jc; da = a; next = NULL; 
}

NodeList::NodeList()
{
	   head = NULL;
	   currNode = NULL;
	   flag = false;
}
NodeList::~NodeList()
{
   	Node * curr = head;
	while (curr != NULL)
	{
	   	head = head->next;
	   	delete curr;
	   	curr = head;
	}
}

void NodeList::insert(int ir, int jc, double a)
{
   	Node * curr, *prev;
	Node * x = new Node(ir,jc,a);
	if (head == NULL)
	{
	   	head = x;
	}
	else if (head->jcola > jc)
	{
	   	x->next = head;
		head = x;
	}
   	else if (head->jcola < jc)
   	{
		curr = head->next;
		prev = head;
		while (1)
		{
			// add to the right of the last  node
			if (curr == NULL)
			{
				prev->next = x;
				break;
			}	
		   	if ( (curr->jcola) > jc)
			{
				x->next = prev->next;
				prev->next = x;
				break;
			}
			else
			{
				curr = curr->next;
				prev = prev->next;
			}
		}
	 }
	 else
	 {
		 cerr << "------ERROR in NodeList::insert function \n";
		 cerr << "input (irowa = " << ir << ", " << jc << ", " << a << ")\n"; 
		 cerr << "output(head->jcolA) = " << head->jcola << endl;
			 
	 }
}
bool NodeList::getData(int &ir, int &jc, double &a)
{
   	if (flag == false)
	{
		// call this function 1st time
		currNode = head;
		flag = true;
	}
	if (currNode == NULL)
		return false;    // nothing left to return
	ir = currNode->irowa;
	jc = currNode->jcola;
	a  = currNode->da;

	currNode = currNode->next;
	   	return true;
}

		
