#ifndef _SBML_READER_H_
#define _SBML_READER_H_

#include "annotationData.h"
const int  N_MATRIX_ELEMENT= 10000 ;
const int  N_METABOLITES  = 1000;
const int  N_REACTIONS    = 2000;

using namespace std;
class sbmlReader
{
  public:
	sbmlReader(char *filename);
	sbmlReader(char *sbml, int string_p);
	~sbmlReader();
	int getNumAnalyses();
	void getDimension(int &nx, int &my, int &mz );
	void getDimension(int &nx, int &my, int &mz, int &nnza, int &nnzq, int &nnzC, int index);
	void getData(double *c, int *irowA, int *jcolA, double *da ,char *ixlow, double *xlow, char *ixupp, double *xupp,string *metName, string * reactionName  );
	void getData(int *irowA, int *jcolA, double *da ,string *metName, string * reactionName  );
	void sortJcolA();
	void writeToSBML(double *fluxes, int fromString_p);
	void writeToSBML(char * filename, int fromString_p);
	void writeToSBML( int fromString_p);
	void writeToSBML(annotationData *AD, int fromString_p);
	void writeToSBML(char * filename, double *fluxes, int fromString_p);
	void print();
	void getQuadraticMatrix( int * irowQ, int nnzQ, int * jcolQ, double * dQ, int index );
	void getLinearEqualityMatrix( int * irowA, int nnzA, int * jcolA, double * dA, double *b, int my, int index );
	void getLinearInequalityMatrix( int * irowC, int nnzC, int * jcolC, double * dC, int index );
	void getObjective(double *objective, int nx, int index);
	void setObjective(double *objective, int nx, int index);
	int getAnalysisType( int analysis );
	void getPrediction(double *prediction, int nx, int index);
	void setPrediction(double *prediction, int nx, int index);
	void getBounds(int nx, char *&ixlow, double *&xlow, char*& ixupp, double*& xupp, int index);
	void getLinearInequalityBounds(int mz, char *iclow, double *clow, char *icupp, double *cupp, int index);

  private:
        int NX, MY, MZ;
        double C[N_REACTIONS];
        double XLOW[N_REACTIONS], XUPP[N_REACTIONS];
        char  IXLOW[N_REACTIONS], IXUPP[N_REACTIONS];
        int   IROWA[N_MATRIX_ELEMENT], JCOLA[N_MATRIX_ELEMENT];
        char  *MetaboliteName[N_METABOLITES], *ReactionName[N_REACTIONS];
        double DA[N_MATRIX_ELEMENT];
	annotationData AD[N_REACTIONS];

        int NNZA;
	char * sbmlDoc;
	int fromString_p;
	string defaultOutput;

	void initialize();
}; 
#endif

