package edu.harvard.med.fluxorspreadsheet;

/**
 * The MetabolismReaction class defines the interface of methods necessary to 
 * get and set data found in a row of a Reaction GUI panel.
 * It is implemented by the {@link ReactionRow} class.
 */


public interface MetabolismReaction {

    
    public String getReactionID();
    public void setReactionID( String sid ) ;
    public String getReactionName( );
    public void setReactionName( String reactionName );
    // public ReactionEquation getReactionEquation( );
    public String getReactionEquation( );
    public void setReactionEquation( ReactionEquation rxnEqn );
    // FluxLimits are strings for now
//     public FluxLimit getReactionWildTypeUpperBound( );
//     public void setReactionWildTypeUpperBound( FluxLimit rxnWTUpBnd );
//     public FluxLimit getReactionWildTypeLowerBound( );
//     public void setReactionWildTypeLowerBound( FluxLimit rxnWTLowBnd );
    public String getReactionWildTypeUpperBound( );
    public void setReactionWildTypeUpperBound( String rxnWTUpBnd );
    public String getReactionWildTypeLowerBound( );
    public void setReactionWildTypeLowerBound( String rxnWTLowBnd );
    public Boolean isReactionKnockout( );
    public void setReactionKnockout( Boolean rxnKO );
    public Float getObjectiveCoefficient( );
    public void setObjectiveCoefficient( Float rxnObjCoef );
    public Float getWildTypeFBA( );
    public void setWildTypeFBA( Float rxnWTFBA );
    public Float getMutantFBA( );
    public void setMutantFBA( Float rxnMutFBA );
    public Float getMOMA( );
    public void setMOMA( Float rxnMOMA );
}
    

