package edu.harvard.med.fluxorspreadsheet;
import java.util.HashMap;
/**
 * The PanelRow class defines the interface of methods necessary to 
 * get and set column data found in a row of a {@link MetabolismPanel} 
 * object.
 * Each panel type requires a specific row implementation.
 *  See {@link SpeciesRow}, {@link ReactionRow} .
 */

public interface PanelRow {
    public String getID();
    public HashMap getColumnData() ;
    public void setColumnData(HashMap columnData);
}
