#ifndef SBW_BROKER_APPLICATION
#define SBW_BROKER_APPLICATION

#include "BrokerDefines.h"

#include <iostream>
#include <string>

namespace SystemsBiologyWorkbench
{
	namespace Broker 
	{
		class BrokerApplication
		{
			static std::string BROKER_VERSION; 
			static bool flagDebug;
			static bool flagNoRemoteBrokers;
			static bool flagRemote;
			static bool flagAllowRemoteModules;
			static bool flagReloadKey;
			static bool flagShutdown;
		public:
			BrokerApplication() { }

			void run(int argc, char* argv[]);
		private:
			void exit_(int code);
			void parseArgs(int argc, char* argv[]);
			void initSessionKey(bool running);
			void startBroker();
			void echoForRemote(bool previouslyRunning);
			static std::string statusToString(int statusCode);
			void printInfo();
			void printUsageAndExit(int exitCode);
			void printError(std::string msg);
			bool addressIsValid(std::string addr);
			bool brokerIsRunning();
			void shutDownBroker();
			bool checkDirArg(std::string path, std::string arg);
			bool checkFileArg(std::string path, std::string arg);
		};
	}
}
#endif
