#include "Host.h"
#include "Sys.h"
using namespace SystemsBiologyWorkbench::Broker;

Host::Host(std::string name)
{
	givenHostName = name;
	fullHostName = Sys::fullyQualifiedHostName(givenHostName);
	hostAddressString = Sys::getHostAddress(fullHostName);
}
Host::Host(std::string name, std::string address)
{
	givenHostName = name;
	fullHostName = Sys::fullyQualifiedHostName(givenHostName);
	hostAddressString = address;
}
std::string Host::getName()
{
	return givenHostName;
}
std::string Host::getFullName()
{
	return fullHostName;
}
std::string Host::getAddress()
{
	return hostAddressString;
}
bool Host::equals(Host *other)
{
	if (hostAddressString == other->getAddress())
		return true;
	return false;
}
