#ifndef SBW_PROPERTIES
#define SBW_PROPERTIES

#include <string>
#include <vector>
#ifndef WIN32
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_map>
#endif

using namespace std;

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{
		class Properties 
		{
		public:
			static Properties* getInstance();
			static void setProperty(std::string sName, std::string sValue);
			static void setProperty(std::string sName, std::string sValue, std::string sDefault);
			static std::string getProperty(std::string sName);
			static std::string getProperty(std::string sName, std::string sDefault);
			static void	removeProperty(std::string sName);
			static bool	hasProperty(std::string sName);
			static void changeProperty(std::string sName, std::string  sValue);
			static std::string toString(int nValue);
			static std::string toString(double dValue);
			
			static int		getPropertyAsInt(std::string sName);
			static double	getPropertyAsDouble(std::string sName);

			static int toInt (std::string sValue);
			static double toDouble (std::string sValue);

			static bool assertConfigProperty(std::string sPropertyName, std::string sExpression);
			static bool assertRuntimeProperty(std::string sPropertyName, std::string sExpression);
			static std::string getConfigProperty(std::string sPropertyName);
			static void save();

		private:
			static Properties* oInstance;
			typedef std::pair<std::string, std::string> StringString;
			//std::vector< StringString > m_oProperties;
			hash_map < std::string, std::string > m_oProperties;
			
		};
	}
}

#endif
