#ifndef SBW_BROKER_PROXY_MODULE_INSTANCE
#define SBW_BROKER_PROXY_MODULE_INSTANCE

#include "InstanceBase.h"
#include "BrokerInstance.h"

#include <string>
#include <iostream>

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{
		class ProxyModuleInstance : public InstanceBase
		{
		public:
			ProxyModuleInstance(int id, int remoteId, std::string name, BrokerInstance *brokerInst);
			virtual int getRemoteId();
			virtual void transmit(unsigned char *data, int length);
			virtual bool connect(std::string key);
			virtual void disconnect();
		private:
			int myRemoteId;
			BrokerInstance *myBrokerInstance;
			SBWOSMutex transmitMutex ;
		};
	}
}

#endif

