#ifndef SBW_BROKER_STARTUP_NOTIFICATION
#define SBW_BROKER_STARTUP_NOTIFICATION

#include <iostream>
#include "Instance.h"
#include "BrokerDefines.h"
#include <vector>
using namespace std;

namespace SystemsBiologyWorkbench
{
	namespace Broker
	{	
		 class StartupNotification
		{
		public:
			class Watcher
			{
			public:
			
				Watcher(std::string str, Instance *instance) { myName = str; myInstance = instance;}
				virtual bool match(std::string str, int brokerId) {
					return (str == myName && brokerId == BROKER_MODULE);
				}
					virtual void notify(Instance *instance) 
					{
						myInstance = instance;
					}
			private:
				std::string myName;
				Instance *myInstance;
			};

			static void addWatcher(Watcher *watcher);
			static  Watcher *matchWatcher(std::string str, int brokerId);
			static  void removeWatcher(Watcher *watcher);
		private:
			static std::vector<Watcher *> startupWatchers;
		};
	}
}

#endif

